function onRun()

  local sel=ldc.selection()

  if (not sel:isLinked()) or (sel:getRefCount()<3) then
    ldc.dialog.runMessage('Please select 3 items')
    return
  end

  local ref={}
  local pos={}
  for i=1,3 do
    ref[i]=sel:getRef(i)
    pos[i]=ref[i]:getPos()
  end
  
  local xx=(pos[2]-pos[1]):getNormalized()
  local zzTmp=(pos[3]-pos[1]):getNormalized()
  local yy=xx:getCross(zzTmp)
  local zz=xx:getCross(yy)
  
  local ori=ldc.matrix()
  ori:setOriCols(xx, yy, zz)
  
  local cor=ldc.matrix()
  cor:setTranslate(pos[1]*-1)
  cor:mulAB(ori)
  cor:mulTranslateAB(pos[1])
  
  local posOri
  for i=1,3 do
    posOri=ref[i]:getPosOri()
    posOri:mulAB(cor)
    ref[i]:setPosOri(posOri)
  end
end

function register()

  local macro=ldc.macro('Level items')
  macro:setEvent('run', 'onRun')
end

register()
